import 'lodash.defaultsdeep';
import 'crypto';
import 'events';
import 'child_process';
import Debug from 'debug';
import { MongoClient } from 'mongodb';
import { performance } from 'perf_hooks';
import { ConnectionString } from 'connection-string';

function _typeof(obj) {
  "@babel/helpers - typeof";

  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function (obj) {
      return typeof obj;
    };
  } else {
    _typeof = function (obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };
  }

  return _typeof(obj);
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: true,
      configurable: true
    }
  });
  if (superClass) _setPrototypeOf(subClass, superClass);
}

function _getPrototypeOf(o) {
  _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  };
  return _getPrototypeOf(o);
}

function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };

  return _setPrototypeOf(o, p);
}

function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !Reflect.construct) return false;
  if (Reflect.construct.sham) return false;
  if (typeof Proxy === "function") return true;

  try {
    Date.prototype.toString.call(Reflect.construct(Date, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}

function _construct(Parent, args, Class) {
  if (_isNativeReflectConstruct()) {
    _construct = Reflect.construct;
  } else {
    _construct = function _construct(Parent, args, Class) {
      var a = [null];
      a.push.apply(a, args);
      var Constructor = Function.bind.apply(Parent, a);
      var instance = new Constructor();
      if (Class) _setPrototypeOf(instance, Class.prototype);
      return instance;
    };
  }

  return _construct.apply(null, arguments);
}

function _isNativeFunction(fn) {
  return Function.toString.call(fn).indexOf("[native code]") !== -1;
}

function _wrapNativeSuper(Class) {
  var _cache = typeof Map === "function" ? new Map() : undefined;

  _wrapNativeSuper = function _wrapNativeSuper(Class) {
    if (Class === null || !_isNativeFunction(Class)) return Class;

    if (typeof Class !== "function") {
      throw new TypeError("Super expression must either be null or a function");
    }

    if (typeof _cache !== "undefined") {
      if (_cache.has(Class)) return _cache.get(Class);

      _cache.set(Class, Wrapper);
    }

    function Wrapper() {
      return _construct(Class, arguments, _getPrototypeOf(this).constructor);
    }

    Wrapper.prototype = Object.create(Class.prototype, {
      constructor: {
        value: Wrapper,
        enumerable: false,
        writable: true,
        configurable: true
      }
    });
    return _setPrototypeOf(Wrapper, Class);
  };

  return _wrapNativeSuper(Class);
}

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return self;
}

function _possibleConstructorReturn(self, call) {
  if (call && (_typeof(call) === "object" || typeof call === "function")) {
    return call;
  }

  return _assertThisInitialized(self);
}

function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();

  return function _createSuperInternal() {
    var Super = _getPrototypeOf(Derived),
        result;

    if (hasNativeReflectConstruct) {
      var NewTarget = _getPrototypeOf(this).constructor;

      result = Reflect.construct(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }

    return _possibleConstructorReturn(this, result);
  };
}
/* eslint-disable no-dupe-class-members */


var SynorError = /*#__PURE__*/function (_Error) {
  _inherits(SynorError, _Error);

  var _super = _createSuper(SynorError);

  function SynorError(message) {
    var _this;

    var type = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'exception';
    var data = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;

    _classCallCheck(this, SynorError);

    _this = _super.call(this, message);
    Error.captureStackTrace(_assertThisInitialized(_this), _this.constructor);

    if (data instanceof Error) {
      _this.stack = "".concat(data.stack, "\n").concat(_this.stack);
    }

    _this.name = _this.constructor.name;
    _this.type = type;
    _this.data = data;
    return _this;
  }

  return SynorError;
}( /*#__PURE__*/_wrapNativeSuper(Error));

var _iteratorSymbol = /*#__PURE__*/typeof Symbol !== "undefined" ? Symbol.iterator || (Symbol.iterator = Symbol("Symbol.iterator")) : "@@iterator";

var _iteratorSymbol$1 = /*#__PURE__*/typeof Symbol !== "undefined" ? Symbol.iterator || (Symbol.iterator = Symbol("Symbol.iterator")) : "@@iterator";
/**
 * JavaScript CRC32 - Stack Overflow - Alex
 * https://stackoverflow.com/a/18639999/4456924
 */


function generateCRC32Table() {
  var crcTable = [];
  var c;

  for (var n = 0; n < 256; n++) {
    c = n;

    for (var k = 0; k < 8; k++) {
      c = c & 1 ? 0xedb88320 ^ c >>> 1 : c >>> 1;
    }

    crcTable[n] = c;
  }

  return crcTable;
}

var crcTable = generateCRC32Table();
/**
 * Generates 32bit signed integer
 */

function crc32(str) {
  var crc = 0 ^ -1;

  for (var i = 0; i < str.length; i++) {
    crc = crc >>> 8 ^ crcTable[(crc ^ str.charCodeAt(i)) & 0xff];
  }

  return (crc ^ -1) >> 0;
}

var synorChecksum = crc32('SYNOR');

function _await(value, then, direct) {
  if (direct) {
    return then ? then(value) : value;
  }

  if (!value || !value.then) {
    value = Promise.resolve(value);
  }

  return then ? value.then(then) : value;
}

var wait = function wait(ms) {
  return new Promise(function (resolve) {
    return setTimeout(resolve, ms);
  });
};

function _async(f) {
  return function () {
    for (var args = [], i = 0; i < arguments.length; i++) {
      args[i] = arguments[i];
    }

    try {
      return Promise.resolve(f.apply(this, args));
    } catch (e) {
      return Promise.reject(e);
    }
  };
}

function _empty() {}

function _awaitIgnored(value, direct) {
  if (!direct) {
    return value && value.then ? value.then(_empty) : Promise.resolve();
  }
}

function _settle(pact, state, value) {
  if (!pact.s) {
    if (value instanceof _Pact) {
      if (value.s) {
        if (state & 1) {
          state = value.s;
        }

        value = value.v;
      } else {
        value.o = _settle.bind(null, pact, state);
        return;
      }
    }

    if (value && value.then) {
      value.then(_settle.bind(null, pact, state), _settle.bind(null, pact, 2));
      return;
    }

    pact.s = state;
    pact.v = value;
    var observer = pact.o;

    if (observer) {
      observer(pact);
    }
  }
}

var _Pact = /*#__PURE__*/function () {
  function _Pact() {}

  _Pact.prototype.then = function (onFulfilled, onRejected) {
    var result = new _Pact();
    var state = this.s;

    if (state) {
      var callback = state & 1 ? onFulfilled : onRejected;

      if (callback) {
        try {
          _settle(result, 1, callback(this.v));
        } catch (e) {
          _settle(result, 2, e);
        }

        return result;
      } else {
        return this;
      }
    }

    this.o = function (_this) {
      try {
        var value = _this.v;

        if (_this.s & 1) {
          _settle(result, 1, onFulfilled ? onFulfilled(value) : value);
        } else if (onRejected) {
          _settle(result, 1, onRejected(value));
        } else {
          _settle(result, 2, value);
        }
      } catch (e) {
        _settle(result, 2, e);
      }
    };

    return result;
  };

  return _Pact;
}();

function _isSettledPact(thenable) {
  return thenable instanceof _Pact && thenable.s & 1;
}

function _for(test, update, body) {
  var stage;

  for (;;) {
    var shouldContinue = test();

    if (_isSettledPact(shouldContinue)) {
      shouldContinue = shouldContinue.v;
    }

    if (!shouldContinue) {
      return result;
    }

    if (shouldContinue.then) {
      stage = 0;
      break;
    }

    var result = body();

    if (result && result.then) {
      if (_isSettledPact(result)) {
        result = result.s;
      } else {
        stage = 1;
        break;
      }
    }

    if (update) {
      var updateValue = update();

      if (updateValue && updateValue.then && !_isSettledPact(updateValue)) {
        stage = 2;
        break;
      }
    }
  }

  var pact = new _Pact();

  var reject = _settle.bind(null, pact, 2);

  (stage === 0 ? shouldContinue.then(_resumeAfterTest) : stage === 1 ? result.then(_resumeAfterBody) : updateValue.then(_resumeAfterUpdate)).then(void 0, reject);
  return pact;

  function _resumeAfterBody(value) {
    result = value;

    do {
      if (update) {
        updateValue = update();

        if (updateValue && updateValue.then && !_isSettledPact(updateValue)) {
          updateValue.then(_resumeAfterUpdate).then(void 0, reject);
          return;
        }
      }

      shouldContinue = test();

      if (!shouldContinue || _isSettledPact(shouldContinue) && !shouldContinue.v) {
        _settle(pact, 1, result);

        return;
      }

      if (shouldContinue.then) {
        shouldContinue.then(_resumeAfterTest).then(void 0, reject);
        return;
      }

      result = body();

      if (_isSettledPact(result)) {
        result = result.v;
      }
    } while (!result || !result.then);

    result.then(_resumeAfterBody).then(void 0, reject);
  }

  function _resumeAfterTest(shouldContinue) {
    if (shouldContinue) {
      result = body();

      if (result && result.then) {
        result.then(_resumeAfterBody).then(void 0, reject);
      } else {
        _resumeAfterBody(result);
      }
    } else {
      _settle(pact, 1, result);
    }
  }

  function _resumeAfterUpdate() {
    if (shouldContinue = test()) {
      if (shouldContinue.then) {
        shouldContinue.then(_resumeAfterTest).then(void 0, reject);
      } else {
        _resumeAfterTest(shouldContinue);
      }
    } else {
      _settle(pact, 1, result);
    }
  }
}

function _continue(value, then) {
  return value && value.then ? value.then(then) : then(value);
}

function _call(body, then, direct) {
  if (direct) {
    return then ? then(body()) : body();
  }

  try {
    var result = Promise.resolve(body());
    return then ? result.then(then) : result;
  } catch (e) {
    return Promise.reject(e);
  }
}

function getQueryStore(db, _ref) {
  var collectionName = _ref.migrationRecordCollection,
      advisoryLockId = _ref.advisoryLockId;
  var lockKey = ['lock', advisoryLockId, 'expires'].join(':');

  var getMigrationRecordCollectionInfo = _async(function () {
    return _await(db.listCollections({
      name: collectionName
    }, {
      batchSize: 1,
      nameOnly: true
    }).toArray(), function (result) {
      var exists = Boolean(result.length);
      return {
        exists: exists
      };
    });
  });

  var createMigrationRecordCollection = _async(function () {
    return _await(db.createCollection(collectionName), function () {
      return _await(db.createIndex(collectionName, 'id', {
        unique: true
      }), function () {
        return _awaitIgnored(db.collection(collectionName).insertOne({
          id: -1,
          nextRecordId: 1
        }));
      });
    });
  });

  var getNextRecordId = _async(function () {
    return _await(db.collection(collectionName).findOneAndUpdate({
      id: -1
    }, {
      $inc: {
        nextRecordId: 1
      }
    }), function (_ref2) {
      var value = _ref2.value;
      return value.nextRecordId;
    });
  });

  var getLock = _async(function () {
    var isLocked = true;
    return _continue(_for(function () {
      return !!isLocked;
    }, void 0, function () {
      return _await(db.collection(collectionName).findOne({
        id: -1
      }, {
        projection: _defineProperty({}, lockKey, 1)
      }), function (document) {
        isLocked = document[lockKey] > Date.now();
        return _awaitIgnored(wait(isLocked ? 5000 : 0));
      });
    }), function () {
      return _awaitIgnored(db.collection(collectionName).updateOne({
        id: -1
      }, {
        $set: _defineProperty({}, lockKey, Date.now() + 5 * 60 * 1000)
      }));
    });
  });

  var releaseLock = _async(function () {
    return _await(db.collection(collectionName).findOne({
      id: -1
    }, {
      projection: _defineProperty({}, lockKey, 1)
    }), function (document) {
      var isLocked = document[lockKey] > Date.now();

      if (!isLocked) {
        throw new Error('not locked!');
      }

      return _awaitIgnored(db.collection(collectionName).updateOne({
        id: -1
      }, {
        $set: _defineProperty({}, lockKey, 0)
      }));
    });
  });

  var getCollectionNames = _async(function () {
    var systemCollectionNameRegex = /^system\./;
    return _await(db.listCollections({}, {
      nameOnly: true
    }).toArray(), function (collections) {
      var collectionNames = collections.map(function (collection) {
        return collection.name;
      }).filter(function (name) {
        return !systemCollectionNameRegex.test(name);
      });
      return collectionNames;
    });
  });

  var dropCollections = _async(function (collectionNames) {
    return _awaitIgnored(Promise.all(collectionNames.map(function (collectionName) {
      return db.dropCollection(collectionName);
    })));
  });

  var getRecords = _async(function () {
    var startId = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;

    if (startId < 0) {
      throw new SynorError('Record ID must can not be negative!');
    }

    return db.collection(collectionName).find({
      id: {
        $gte: startId
      }
    }).project({
      _id: 0
    }).toArray();
  });

  var addRecord = function addRecord(_ref3) {
    var version = _ref3.version,
        type = _ref3.type,
        title = _ref3.title,
        hash = _ref3.hash,
        appliedAt = _ref3.appliedAt,
        appliedBy = _ref3.appliedBy,
        executionTime = _ref3.executionTime,
        dirty = _ref3.dirty;
    return _call(getNextRecordId, function (nextId) {
      return _awaitIgnored(db.collection(collectionName).insertOne({
        id: nextId,
        version: version,
        type: type,
        title: title,
        hash: hash,
        appliedAt: appliedAt,
        appliedBy: appliedBy,
        executionTime: Math.floor(executionTime),
        dirty: dirty
      }));
    });
  };

  var deleteDirtyRecords = _async(function () {
    return _awaitIgnored(db.collection(collectionName).deleteMany({
      dirty: true
    }));
  });

  var updateRecord = _async(function (id, _ref4) {
    var hash = _ref4.hash;
    return _awaitIgnored(db.collection(collectionName).updateOne({
      id: id
    }, {
      $set: {
        hash: hash
      }
    }));
  });

  return {
    getMigrationRecordCollectionInfo: getMigrationRecordCollectionInfo,
    createMigrationRecordCollection: createMigrationRecordCollection,
    getLock: getLock,
    releaseLock: releaseLock,
    getCollectionNames: getCollectionNames,
    dropCollections: dropCollections,
    getRecords: getRecords,
    addRecord: addRecord,
    deleteDirtyRecords: deleteDirtyRecords,
    updateRecord: updateRecord
  };
}

function _empty$1() {}

function _awaitIgnored$1(value, direct) {
  if (!direct) {
    return value && value.then ? value.then(_empty$1) : Promise.resolve();
  }
}

function _await$1(value, then, direct) {
  if (direct) {
    return then ? then(value) : value;
  }

  if (!value || !value.then) {
    value = Promise.resolve(value);
  }

  return then ? value.then(then) : value;
}

function _async$1(f) {
  return function () {
    for (var args = [], i = 0; i < arguments.length; i++) {
      args[i] = arguments[i];
    }

    try {
      return Promise.resolve(f.apply(this, args));
    } catch (e) {
      return Promise.reject(e);
    }
  };
}

var ensureMigrationRecordCollection = _async$1(function (queryStore, baseVersion) {
  return _await$1(queryStore.getMigrationRecordCollectionInfo(), function (collectionInfo) {
    if (collectionInfo.exists) {
      return;
    }

    var startTime = performance.now();
    return _await$1(queryStore.createMigrationRecordCollection(), function () {
      var endTime = performance.now();
      return _awaitIgnored$1(queryStore.addRecord({
        version: baseVersion,
        type: 'do',
        title: 'Base Entry',
        hash: '',
        appliedAt: new Date(),
        appliedBy: 'Synor',
        executionTime: endTime - startTime,
        dirty: false
      }));
    });
  });
});

var validProtocol = ['mongodb', 'mongodb+srv'];
function getConfig(uri) {
  try {
    var _ConnectionString = new ConnectionString(uri, {
      params: {
        appname: '@synor/database-mongodb',
        synor_migration_record_collection: 'synor_migration_record'
      }
    }),
        protocol = _ConnectionString.protocol,
        host = _ConnectionString.hostname,
        path = _ConnectionString.path,
        params = _ConnectionString.params;

    if (!protocol) {
      throw new Error("[URI] missing: protocol!");
    }

    if (!validProtocol.includes(protocol)) {
      throw new Error("[URI] unsupported: protocol(".concat(protocol, ")!"));
    }

    if (!host) {
      throw new Error("[URI] missing: host!");
    }

    var database = path === null || path === void 0 ? void 0 : path[0];

    if (!database) {
      throw new Error('[URI] missing: database!');
    }

    var databaseConfig = {
      appname: params.appname,
      database: database
    };
    var engineConfig = {
      migrationRecordCollection: params.synor_migration_record_collection
    };
    return {
      databaseConfig: databaseConfig,
      engineConfig: engineConfig
    };
  } catch (error) {
    throw new SynorError('Invalid DatabaseURI', 'exception', error);
  }
}

function _empty$2() {}

var debug = Debug('@synor/database-mongodb');

function _awaitIgnored$2(value, direct) {
  if (!direct) {
    return value && value.then ? value.then(_empty$2) : Promise.resolve();
  }
}

function _await$2(value, then, direct) {
  if (direct) {
    return then ? then(value) : value;
  }

  if (!value || !value.then) {
    value = Promise.resolve(value);
  }

  return then ? value.then(then) : value;
}

function _call$1(body, then, direct) {
  if (direct) {
    return then ? then(body()) : body();
  }

  try {
    var result = Promise.resolve(body());
    return then ? result.then(then) : result;
  } catch (e) {
    return Promise.reject(e);
  }
}

function _async$2(f) {
  return function () {
    for (var args = [], i = 0; i < arguments.length; i++) {
      args[i] = arguments[i];
    }

    try {
      return Promise.resolve(f.apply(this, args));
    } catch (e) {
      return Promise.reject(e);
    }
  };
}

function _catch(body, recover) {
  try {
    var result = body();
  } catch (e) {
    return recover(e);
  }

  if (result && result.then) {
    return result.then(void 0, recover);
  }

  return result;
}

var _iteratorSymbol$2 = /*#__PURE__*/typeof Symbol !== "undefined" ? Symbol.iterator || (Symbol.iterator = Symbol("Symbol.iterator")) : "@@iterator";

function _settle$1(pact, state, value) {
  if (!pact.s) {
    if (value instanceof _Pact$1) {
      if (value.s) {
        if (state & 1) {
          state = value.s;
        }

        value = value.v;
      } else {
        value.o = _settle$1.bind(null, pact, state);
        return;
      }
    }

    if (value && value.then) {
      value.then(_settle$1.bind(null, pact, state), _settle$1.bind(null, pact, 2));
      return;
    }

    pact.s = state;
    pact.v = value;
    var observer = pact.o;

    if (observer) {
      observer(pact);
    }
  }
}

var _Pact$1 = /*#__PURE__*/function () {
  function _Pact() {}

  _Pact.prototype.then = function (onFulfilled, onRejected) {
    var result = new _Pact();
    var state = this.s;

    if (state) {
      var callback = state & 1 ? onFulfilled : onRejected;

      if (callback) {
        try {
          _settle$1(result, 1, callback(this.v));
        } catch (e) {
          _settle$1(result, 2, e);
        }

        return result;
      } else {
        return this;
      }
    }

    this.o = function (_this) {
      try {
        var value = _this.v;

        if (_this.s & 1) {
          _settle$1(result, 1, onFulfilled ? onFulfilled(value) : value);
        } else if (onRejected) {
          _settle$1(result, 1, onRejected(value));
        } else {
          _settle$1(result, 2, value);
        }
      } catch (e) {
        _settle$1(result, 2, e);
      }
    };

    return result;
  };

  return _Pact;
}();

function _isSettledPact$1(thenable) {
  return thenable instanceof _Pact$1 && thenable.s & 1;
}

function _forTo(array, body, check) {
  var i = -1,
      pact,
      reject;

  function _cycle(result) {
    try {
      while (++i < array.length && (!check || !check())) {
        result = body(i);

        if (result && result.then) {
          if (_isSettledPact$1(result)) {
            result = result.v;
          } else {
            result.then(_cycle, reject || (reject = _settle$1.bind(null, pact = new _Pact$1(), 2)));
            return;
          }
        }
      }

      if (pact) {
        _settle$1(pact, 1, result);
      } else {
        pact = result;
      }
    } catch (e) {
      _settle$1(pact || (pact = new _Pact$1()), 2, e);
    }
  }

  _cycle();

  return pact;
}

function _forOf(target, body, check) {
  if (typeof target[_iteratorSymbol$2] === "function") {
    var _cycle2 = function _cycle2(result) {
      try {
        while (!(step = iterator.next()).done && (!check || !check())) {
          result = body(step.value);

          if (result && result.then) {
            if (_isSettledPact$1(result)) {
              result = result.v;
            } else {
              result.then(_cycle2, reject || (reject = _settle$1.bind(null, pact = new _Pact$1(), 2)));
              return;
            }
          }
        }

        if (pact) {
          _settle$1(pact, 1, result);
        } else {
          pact = result;
        }
      } catch (e) {
        _settle$1(pact || (pact = new _Pact$1()), 2, e);
      }
    };

    var iterator = target[_iteratorSymbol$2](),
        step,
        pact,
        reject;

    _cycle2();

    if (iterator["return"]) {
      var _fixup = function _fixup(value) {
        try {
          if (!step.done) {
            iterator["return"]();
          }
        } catch (e) {}

        return value;
      };

      if (pact && pact.then) {
        return pact.then(_fixup, function (e) {
          throw _fixup(e);
        });
      }

      _fixup();
    }

    return pact;
  } // No support for Symbol.iterator


  if (!("length" in target)) {
    throw new TypeError("Object is not iterable");
  } // Handle live collections properly


  var values = [];

  for (var i = 0; i < target.length; i++) {
    values.push(target[i]);
  }

  return _forTo(values, function (i) {
    return body(values[i]);
  }, check);
}

function _continueIgnored(value) {
  if (value && value.then) {
    return value.then(_empty$2);
  }
}

function _invokeIgnored(body) {
  var result = body();

  if (result && result.then) {
    return result.then(_empty$2);
  }
}

function _rethrow(thrown, value) {
  if (thrown) throw value;
  return value;
}

function _finallyRethrows(body, finalizer) {
  try {
    var result = body();
  } catch (e) {
    return finalizer(true, e);
  }

  if (result && result.then) {
    return result.then(finalizer.bind(null, false), finalizer.bind(null, true));
  }

  return finalizer(false, result);
}

var MongoDBDatabaseEngine = function MongoDBDatabaseEngine(uri, _ref) {
  var baseVersion = _ref.baseVersion,
      getAdvisoryLockId = _ref.getAdvisoryLockId,
      getUserInfo = _ref.getUserInfo;

  if (typeof getAdvisoryLockId !== 'function') {
    throw new SynorError("Missing: getAdvisoryLockId");
  }

  if (typeof getUserInfo !== 'function') {
    throw new SynorError("Missing: getUserInfo");
  }

  var _getConfig = getConfig(uri),
      databaseConfig = _getConfig.databaseConfig,
      engineConfig = _getConfig.engineConfig;

  var advisoryLockId = getAdvisoryLockId(databaseConfig.database, engineConfig.migrationRecordCollection).join(':');
  var client;
  var db;
  var queryStore;
  var appliedBy = '';

  var open = _async$2(function () {
    debug('open');
    return _call$1(getUserInfo, function (_getUserInfo) {
      appliedBy = _getUserInfo;
      return _await$2(MongoClient.connect(uri, {
        appname: databaseConfig.appname,
        poolSize: 1,
        useUnifiedTopology: true
      }), function (_MongoClient$connect) {
        client = _MongoClient$connect;
        db = client.db(databaseConfig.database);
        queryStore = getQueryStore(db, {
          migrationRecordCollection: engineConfig.migrationRecordCollection,
          advisoryLockId: advisoryLockId
        });
        return _awaitIgnored$2(ensureMigrationRecordCollection(queryStore, baseVersion));
      });
    });
  });

  var close = _async$2(function () {
    debug('close');
    return _awaitIgnored$2(client.close());
  });

  var lock = _async$2(function () {
    debug('lock');
    return _catch(function () {
      return _awaitIgnored$2(queryStore.getLock());
    }, function () {
      throw new SynorError("Failed to Get Lock: ".concat(advisoryLockId));
    });
  });

  var unlock = _async$2(function () {
    debug('unlock');
    return _catch(function () {
      return _awaitIgnored$2(queryStore.releaseLock());
    }, function () {
      throw new SynorError("Failed to Release Lock: ".concat(advisoryLockId));
    });
  });

  var drop = _async$2(function () {
    debug('drop');
    return _await$2(queryStore.getCollectionNames(), function (collectionNames) {
      return _awaitIgnored$2(queryStore.dropCollections(collectionNames));
    });
  });

  var run = _async$2(function (_ref2) {
    var version = _ref2.version,
        type = _ref2.type,
        title = _ref2.title,
        hash = _ref2.hash,
        body = _ref2.body,
        run = _ref2.run;
    debug('run');
    var dirty = false;
    var startTime = performance.now();
    return _finallyRethrows(function () {
      return _catch(function () {
        return _invokeIgnored(function () {
          if (body) {
            var parsedBody = JSON.parse(body);
            var commands = Array.isArray(parsedBody) ? parsedBody : [parsedBody];
            return _continueIgnored(_forOf(commands, function (command) {
              return _awaitIgnored$2(db.command(command));
            }));
          } else {
            return _awaitIgnored$2(run(db));
          }
        });
      }, function (err) {
        dirty = true;
        throw err;
      });
    }, function (_wasThrown, _result3) {
      var endTime = performance.now();
      return _await$2(queryStore.addRecord({
        version: version,
        type: type,
        title: title,
        hash: hash,
        appliedAt: new Date(),
        appliedBy: appliedBy,
        executionTime: endTime - startTime,
        dirty: dirty
      }), function () {
        return _rethrow(_wasThrown, _result3);
      });
    });
  });

  var repair = _async$2(function (records) {
    debug('repair');
    return _await$2(queryStore.deleteDirtyRecords(), function () {
      return _continueIgnored(_forOf(records, function (_ref3) {
        var id = _ref3.id,
            hash = _ref3.hash;
        return _awaitIgnored$2(queryStore.updateRecord(id, {
          hash: hash
        }));
      }));
    });
  });

  var records = _async$2(function (startId) {
    debug('records');
    return queryStore.getRecords(startId);
  });

  return {
    open: open,
    close: close,
    lock: lock,
    unlock: unlock,
    drop: drop,
    run: run,
    repair: repair,
    records: records
  };
};

export default MongoDBDatabaseEngine;
export { MongoDBDatabaseEngine };
