declare type Db = import('mongodb').Db;
declare type MigrationRecord = import('@synor/core').MigrationRecord;
export declare type QueryStore = {
    getMigrationRecordCollectionInfo: () => Promise<{
        exists: boolean;
    }>;
    createMigrationRecordCollection: () => Promise<void>;
    getLock: () => Promise<void>;
    releaseLock: () => Promise<void>;
    getCollectionNames: () => Promise<string[]>;
    dropCollections: (collectionNames: string[]) => Promise<void>;
    getRecords: (startId?: number) => Promise<MigrationRecord[]>;
    addRecord: (record: Omit<MigrationRecord, 'id'>) => Promise<void>;
    deleteDirtyRecords: () => Promise<void>;
    updateRecord: (id: MigrationRecord['id'], data: Pick<MigrationRecord, 'hash'>) => Promise<void>;
};
declare type QueryStoreOptions = {
    migrationRecordCollection: string;
    advisoryLockId: string;
};
export declare function getQueryStore(db: Db, { migrationRecordCollection: collectionName, advisoryLockId, }: QueryStoreOptions): QueryStore;
export {};
